/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex2;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.EventHandler;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

/**
 *
 * @author rosmord
 */
public class CalculetteApp {

    JCalculette frame;
    CalculetteModele modele;

    public CalculetteApp() {
        frame = new JCalculette();
        modele = new CalculetteModele();
        activer();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                new CalculetteApp();
            }
        });
    }

    public void traiterBoutonChiffre(String label) {
        modele.ajouterSymbole(label.charAt(0));
        frame.getResultatField().setText(modele.getAffichage());
    }

    public void traiterMoins() {
        modele.soustraireOp();
        frame.getResultatField().setText(modele.getAffichage());
    }

    public void traiterPlus() {
                modele.additionnerOp();
        frame.getResultatField().setText(modele.getAffichage());

    }

    public void traiterMultiplier() {
        modele.multiplierOp();
        frame.getResultatField().setText(modele.getAffichage());

    }

    public void traiterEgal() {
        modele.egalOp();
        frame.getResultatField().setText(modele.getAffichage());
    }

    public void traiterDiviser() {
        modele.diviserOp();
        frame.getResultatField().setText(modele.getAffichage());
    }

    private void activer() {
        // Les chiffres
        JButton chiffres[] = {
            frame.getBouton0(),
            frame.getBouton1(),
            frame.getBouton2(),
            frame.getBouton3(),
            frame.getBouton4(),
            frame.getBouton5(),
            frame.getBouton6(),
            frame.getBouton7(),
            frame.getBouton8(),
            frame.getBouton9(),
            frame.getBoutonPoint()
        };
        for (JButton b : chiffres) {
            b.addActionListener(new BoutonChiffreListener(b));
        }
        // Les opérateurs.
        frame.getBoutonPlus().addActionListener(EventHandler.create(ActionListener.class, this, "traiterPlus"));
        frame.getBoutonMoins().addActionListener(EventHandler.create(ActionListener.class, this, "traiterMoins"));
        frame.getBoutonMultiplier().addActionListener(EventHandler.create(ActionListener.class, this, "traiterMultiplier"));
        frame.getBoutonDiviser().addActionListener(EventHandler.create(ActionListener.class, this, "traiterDiviser"));
        frame.getBoutonEgal().addActionListener(EventHandler.create(ActionListener.class, this, "traiterEgal"));
    }

    private class BoutonChiffreListener implements ActionListener {

        private JButton button;

        public BoutonChiffreListener(JButton button) {
            this.button = button;
        }

        @Override
        public void actionPerformed(ActionEvent e) {
            traiterBoutonChiffre(button.getText());

        }
    }
}
