/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex1;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.EventHandler;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

/**
 *
 * @author rosmord
 */
public class FormeSimpleApp {

    private JFormeSimple frame = new JFormeSimple();

    public FormeSimpleApp() {
        // Solution avec classe anonyme.
        frame.getChercherButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                chercher();
            }
        });
        
        // Autre solution avec un listener classique.
        //frame.getChercherButton().
        //        addActionListener(new ChercherListener(this));
        
        // Solution avec un EventHandler.
        //frame.getChercherButton().addActionListener(
        //        EventHandler.create(ActionListener.class,
        //        this, "chercher")
        //        );
        
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }

    public void chercher() {
        String contenu = frame.getContenuTextArea().getText();
        String aChercher = frame.getRechercheTextField().getText();
        
        if ("".equals(aChercher)) {
            return;
        }
        
        int pos= contenu.indexOf(aChercher);
        
        frame.getContenuTextArea().requestFocusInWindow();

        if (pos== -1) {
            frame.getContenuTextArea().select(0, 0);
        } else {
            frame.getContenuTextArea().select(
                    pos, pos+aChercher.length());
        }
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                new FormeSimpleApp();
            }
        });
    }
}
